#ifndef FRAGINFO_H
#define FRAGINFO_H

#define MAX_ORDER 10
typedef __u64 u64;
struct order_zone{
    unsigned int order;
    u64 zone_ptr;
};
struct ctg_info {
	long unsigned int free_pages;
	long unsigned int free_blocks_total;
	long unsigned int free_blocks_suitable;
};

struct zone_info
{
    u64 zone_ptr;
    u64 zone_start_pfn;
    //spanned_pages: 代表的是这个zone中所有的页，包含空洞，计算公式是: zone_end_pfn - zone_start_pfn
    //present_pages： 代表的是这个zone中可用的所有物理页，计算公式是：spanned_pages-hole_pages
    u64 spanned_pages;
    u64 present_pages;
    char comm[32];
    unsigned int order;
};

struct pgdat_info //pgdat 结构用于描述物理内存节点（NUMA节点）的一些信息，如该节点的内存区域、内存区域列表等。
{
    u64 pgdat_ptr;  //通过 pgdat_ptr 可以访问该节点的详细数据。
    int nr_zones;   //内存节点中存在的区域（zones）的数量
    int node_id;    //内存节点的 ID
};

#endif
