// Copyright 2023 The LMP Authors.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
// https://github.com/linuxkerneltravel/lmp/blob/develop/LICENSE
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// author: blown.away@qq.com
// netwatcher libbpf 丢包原因

#ifndef __DROPREASON_H
#define __DROPREASON_H
const char *SKB_Drop_Reason_Strings[] = {
    "SKB_NOT_DROPPED_YET",
    "SKB_CONSUMED",
    "SKB_DROP_REASON_NOT_SPECIFIED",
    "SKB_DROP_REASON_NO_SOCKET",
    "SKB_DROP_REASON_PKT_TOO_SMALL",
    "SKB_DROP_REASON_TCP_CSUM",
    "SKB_DROP_REASON_SOCKET_FILTER",
    "SKB_DROP_REASON_UDP_CSUM",
    "SKB_DROP_REASON_NETFILTER_DROP",
    "SKB_DROP_REASON_OTHERHOST",
    "SKB_DROP_REASON_IP_CSUM",
    "SKB_DROP_REASON_IP_INHDR",
    "SKB_DROP_REASON_IP_RPFILTER",
    "SKB_DROP_REASON_UNICAST_IN_L2_MULTICAST",
    "SKB_DROP_REASON_XFRM_POLICY",
    "SKB_DROP_REASON_IP_NOPROTO",
    "SKB_DROP_REASON_SOCKET_RCVBUFF",
    "SKB_DROP_REASON_PROTO_MEM",
    "SKB_DROP_REASON_TCP_MD5NOTFOUND",
    "SKB_DROP_REASON_TCP_MD5UNEXPECTED",
    "SKB_DROP_REASON_TCP_MD5FAILURE",
    "SKB_DROP_REASON_SOCKET_BACKLOG",
    "SKB_DROP_REASON_TCP_FLAGS",
    "SKB_DROP_REASON_TCP_ZEROWINDOW",
    "SKB_DROP_REASON_TCP_OLD_DATA",
    "SKB_DROP_REASON_TCP_OVERWINDOW",
    "SKB_DROP_REASON_TCP_OFOMERGE",
    "SKB_DROP_REASON_TCP_RFC7323_PAWS",
    "SKB_DROP_REASON_TCP_INVALID_SEQUENCE",
    "SKB_DROP_REASON_TCP_RESET",
    "SKB_DROP_REASON_TCP_INVALID_SYN",
    "SKB_DROP_REASON_TCP_CLOSE",
    "SKB_DROP_REASON_TCP_FASTOPEN",
    "SKB_DROP_REASON_TCP_OLD_ACK",
    "SKB_DROP_REASON_TCP_TOO_OLD_ACK",
    "SKB_DROP_REASON_TCP_ACK_UNSENT_DATA",
    "SKB_DROP_REASON_TCP_OFO_QUEUE_PRUNE",
    "SKB_DROP_REASON_TCP_OFO_DROP",
    "SKB_DROP_REASON_IP_OUTNOROUTES",
    "SKB_DROP_REASON_BPF_CGROUP_EGRESS",
    "SKB_DROP_REASON_IPV6DISABLED",
    "SKB_DROP_REASON_NEIGH_CREATEFAIL",
    "SKB_DROP_REASON_NEIGH_FAILED",
    "SKB_DROP_REASON_NEIGH_QUEUEFULL",
    "SKB_DROP_REASON_NEIGH_DEAD",
    "SKB_DROP_REASON_TC_EGRESS",
    "SKB_DROP_REASON_QDISC_DROP",
    "SKB_DROP_REASON_CPU_BACKLOG",
    "SKB_DROP_REASON_XDP",
    "SKB_DROP_REASON_TC_INGRESS",
    "SKB_DROP_REASON_UNHANDLED_PROTO",
    "SKB_DROP_REASON_SKB_CSUM",
    "SKB_DROP_REASON_SKB_GSO_SEG",
    "SKB_DROP_REASON_SKB_UCOPY_FAULT",
    "SKB_DROP_REASON_DEV_HDR",
    "SKB_DROP_REASON_DEV_READY",
    "SKB_DROP_REASON_FULL_RING",
    "SKB_DROP_REASON_NOMEM",
    "SKB_DROP_REASON_HDR_TRUNC",
    "SKB_DROP_REASON_TAP_FILTER",
    "SKB_DROP_REASON_TAP_TXFILTER",
    "SKB_DROP_REASON_ICMP_CSUM",
    "SKB_DROP_REASON_INVALID_PROTO",
    "SKB_DROP_REASON_IP_INADDRERRORS",
    "SKB_DROP_REASON_IP_INNOROUTES",
    "SKB_DROP_REASON_PKT_TOO_BIG",
    "SKB_DROP_REASON_DUP_FRAG",
    "SKB_DROP_REASON_FRAG_REASM_TIMEOUT",
    "SKB_DROP_REASON_FRAG_TOO_FAR",
    "SKB_DROP_REASON_TCP_MINTTL",
    "SKB_DROP_REASON_IPV6_BAD_EXTHDR",
    "SKB_DROP_REASON_IPV6_NDISC_FRAG",
    "SKB_DROP_REASON_IPV6_NDISC_HOP_LIMIT",
    "SKB_DROP_REASON_IPV6_NDISC_BAD_CODE",
    "SKB_DROP_REASON_IPV6_NDISC_BAD_OPTIONS",
    "SKB_DROP_REASON_IPV6_NDISC_NS_OTHERHOST",
    "SKB_DROP_REASON_MAX",
    "SKB_DROP_REASON_SUBSYS_MASK",
};
#endif